{Il gioco  stato realizzato tra il 10 e il 16 Dicembre del 1999 da
 Vincenzo Scognamiglio come esercitazione del corso di Programmazione I
 modulo A del corso di Laurea in Informatica della Federico II per l'anno
 accademico 1999/2000. Sono previste eventuali revisioni del gioco, chi avr
 in mano questa versione sorgente  pregato di contattarmi, se possibile, per
 tutti  i buchi o per dare suggerimenti, ricordando bene che non esiste
 programma perfetto e definitivo.}
Program Gioco_Dell_Oca;

uses  Drivers, Graph, Graph3, Crt;

 {Dichiarazione del formato del record per il salvataggio della TOP TEN}
 Type
  Classificato = Record
   Cognome : String;
   Nome    : String;
   Punti   : Integer;
   Computer: Boolean;
  end;

 {Dichiarazione del formato del record per le oche, da notare che c' un campo
  di tipo Classificato utilizzato per gestire il giocatore abbinato all'oca}
 Type
  Oca = Record
   Giocatore   : Classificato;
   Disegno     : ARRAY [1 ..  2]  OF Pointer;
   Posizione   : Integer;
   Decina      : Integer;
   Mosse       : Integer;
   Turno_Fermo : Boolean;
  end;

 {Variabili globali}
 Var

  {Creazione delle oche}
  Verde, Rossa : Oca;

  {Vettore utilizzato per l'aggiunta del carattere space o  nel men iniziale}
  Sel                                : ARRAY [1 ..  5]  OF Char;

  {Vettore utilizzato per il caricamento e la modifica della TOP TEN}
  Classifica                         : ARRAY [1 .. 10]  OF Classificato;

  {Caratteri utilizzati per l'attesa e per il controllo sui tasti speciali}
  WaitChar, ReadChar                 : Char;

  {Variabili di gestione del gioco}
  Tiro, Gioco_In_Corso               :Boolean;

  {Variabile per conoscere la scelta fatta dall'utente con la procedura Men}
  Selezionato                        : Integer;

  {Tabella di gioco}
  Percorso                           : ARRAY [1 .. 90] OF INTEGER;

{Procedura utillizzata per impostare la posizione del carattere  nel men}
Procedure Imposta_Sel(Posizione: integer);
  Var
   XXX                               :Integer;

begin
 For XXX:=1 to 5  Do Sel[XXX]:=' ';
 Sel[Posizione]:='';
End;

{Procedura per l'inizializzazione automatica del modo grafico}
Procedure InGraph;
  var
  grDriver: Integer;
  grMode: Integer;
  ErrCode: Integer;

 begin
  grDriver := Detect;
  InitGraph(grDriver, grMode,'');
  ErrCode := GraphResult;
  if ErrCode <> grOk then Writeln('Errore nell''inizializzazione grafica:', GraphErrorMsg(ErrCode));
 end;

{Procedura che realizza l'animazione grafica all'avvio del programma}
Procedure Presentazione;
 var
  CN,XX:integer;
  Size: word;

 Begin
 {Scritte verticali e relativa animazione e musica}
 SetUserCharSize(40, 10, 10, 10);
 settextstyle(3,5,7);
 For XX:=1 to 6 do
  For CN:=0 to 10 do
   begin
    SetColor(CN+XX);
    outtextxy(CN*60,0,'Il gioco dell''oca');
    Sound((CN+1)*10);
    Delay(50);
    NoSound;
   end;

 {Striscia rossa centrale con entrata a 'persiana'}
 SetColor(RED);
 For CN:=0 to 360 do
  begin
   line((CN*2),170,(2*CN),270);
   line(GetMaxX-(CN*2),170,GetMaxX-(2*CN),270);
   Sound(10+CN);
   Delay(30);
   NoSound;
  end;

 {Scritte nella striscia rossa}
 SetColor(YELLOW);
 settextstyle(4,0,7);
 outtextxy(30,150,' il gioco dell''oca 1.1');
 setcolor(GREEN);
 settextstyle(3,0,4);
 outtextxy(75,230,'A cura di Vincenzo Scognamiglio');
 Sound (540);
 delay(1000);
 NoSound;

 {Disegno dell'oca verde 1}
 SetColor(GREEN);
 SetFillStyle(1, GREEN);
 FillEllipse(25,429,15, 8);
 FillEllipse(38,411,8, 4);
 SetFillStyle(1, GREEN);
 SetColor(GREEN);
 for CN:=0 to 10 do line(30+CN,412,30+CN,426);
 SetColor(YELLOW);
 for CN := 1 to 3 Do line(46, 410 + CN, 50, 410 + CN);
 line (25,438,30,444);
 line (23,438,25,444);
 Setcolor (BLACK);
 Rectangle (36,410,38,411);
 SetColor(GREEN);
 Size := ImageSize(0,405,50,445);
 GetMem(Verde.Disegno[1], Size);
 getimage(0,405,50,445,Verde.Disegno[1]^);
 putimage(0,405,Verde.Disegno[1]^,XORPut);

 {Disegno dell'oca verde 2}
 SetColor(GREEN);
 FillEllipse(25,429,15, 8);
 FillEllipse(38,411,8, 4);
 For CN := 0 To 10 Do line(30+CN,412,30+CN,426);
 SetColor(YELLOW);
 for CN := 1 to 3  Do line(46, 410 + CN, 50, 410 + CN);
 line (25,438,23,444);
 line (23,438,25,444);
 Setcolor (BLACK);
 Rectangle (36,410,38,411);
 Size := ImageSize(0,405,50,445);
 GetMem(Verde.Disegno[2], Size);
 getimage(0,405,50,445,Verde.Disegno[2]^);
 putimage(0,405,Verde.Disegno[2]^,XORPut);

 {Disegno dell'oca rossa 1}
 setcolor(RED);
 SetFillStyle(1,RED);
 FillEllipse(25,429,15, 8);
 FillEllipse(38,411,8, 4);
 SetColor(YELLOW);
 for CN := 1 to 3  Do line(46, 410 + CN, 50, 410 + CN);
 SetColor(RED);
 for CN:=0 to 10 do line(30+CN,412,30+CN,426);
 SetColor(YELLOW);
 for CN := 1 to 3 Do line(46, 410 + CN, 50, 410 + CN);
 line (25,438,30,444);
 line (23,438,25,444);
 Setcolor (BLACK);
 Rectangle (36,410,38,411);
 SetColor(RED);
 Size := ImageSize(0,405,50,445);
 GetMem(Rossa.Disegno[1], Size);
 getimage(0,405,50,445,Rossa.Disegno[1]^);
 putimage(0,405,Rossa.Disegno[1]^,XORPut);

 {Disegno dell'oca rossa 2}
 FillEllipse(25,429,15, 8);
 FillEllipse(38,411,8, 4);
 SetColor(YELLOW);
 for CN := 1 to 3  Do line(46, 410 + CN, 50, 410 + CN);
 SetColor(RED);
 for CN:=0 to 10 do line(30+CN,412,30+CN,426);
 SetColor(YELLOW);
 for CN := 1 to 3 Do line(46, 410 + CN, 50, 410 + CN);
 line (25,438,23,444);
 line (23,438,25,444);
 Setcolor (BLACK);
 Rectangle (36,410,38,411);
 SetColor(RED);
 Size := ImageSize(0,405,50,445);
 GetMem(Rossa.Disegno[2], Size);
 getimage(0,405,50,445,Rossa.Disegno[2]^);
 putimage(0,405,Rossa.Disegno[2]^,XORPut);

 {Disegno delle oche alternate nella parte bassa dello schermo }
 For CN:=0 to 8 do
 begin
   putimage(CN*45*4,405,Rossa.Disegno[1]^,XORPut);
   putimage(46+CN*45*4,405,Verde.Disegno[2]^,XORPut);
   putimage(92+CN*45*4,405,Rossa.Disegno[2]^,XORPut);
   putimage(128+CN*45*4,405,Verde.Disegno[1]^,XORPut);
  end;
 repeat until  (Keypressed);
 WaitChar := ReadKey;
End;

{Funzione che crea il men principale , ne permette il movimento all'interno
 interagendo con la procedura Imposta_Sel e ritornando come valore il numero
 relativo all'opzione selezionata poi gestito dal blocco principale}
function Menu:integer;
  Var
   Selezionatore, XYZ : integer;
   Continua           : Boolean;
   Stringa            :   string;

Begin
 Selezionatore:=1;
 Continua:=True;
 Imposta_Sel(Selezionatore);
 TextBackground (BLACK);
 TextColor(BLUE);
  while (Continua=True) do
   Begin
    {Per una migliore comprensione dell'output su schermo e degli allineamenti della tabella
     si  preferito fare ricorso a spazi non 'significativi' e si  evitato l'uso della
     procedura GotoXY in vari punti}
    clrscr;
    writeln('                              IL GIOCO DELL''OCA               ');
    writeln('                                                               ');
    writeln( '                   Programma a cura di Vincenzo Scognamiglio  ');
    writeln('                        realizzato nel Dicembre 1999           ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                          Ŀ          ');
    writeln('                               Men principale               ');
    writeln('                          Ĵ          ');
    writeln('                                                             ');
    writeln('                               ',Sel[1],' 1.Gioca subito     ');
    writeln('                               ',Sel[2],' 2.Istruzioni       ');
    writeln('                               ',Sel[3],' 3.Top 10           ');
    writeln('                               ',Sel[4],' 4.Crea tabella     ');
    writeln('                               ',Sel[5],' 5.Esci             ');
    writeln('                                    ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                                                               ');
    writeln('                                                               ');
  repeat until (Keypressed);
  ReadChar:=ReadKey;

  {Controllo sul tasto premuto per verificare se  assegnato a qualche evento}
  case ReadChar of
    #13: Continua:=False;                      {E' stato premuto ENTER}
    #80: Selezionatore:=Selezionatore + 1;     {E' stato premuto DOWN }
    #72: Selezionatore:=Selezionatore - 1;     {E' stato premuto UP   }
    #27: Halt(1);                              {E' stato premuto ESC  }
  end;

  {Verifica sulla posizione del selezionatore }
  if Selezionatore > 5 then Selezionatore := 1;
  if Selezionatore < 1 then Selezionatore := 5;
  Imposta_Sel(Selezionatore);
 end;
 Menu:=Selezionatore;
End;

{Suona NNote note a caso  per la durata di duecento millisecondi ciascuna}
Procedure Suona(NNote :integer);
 Var
 CNSuoni: Integer;

Begin
 For CNSuoni := 1 to NNote do
 begin
  sound(Random (390)+ 130);
  Delay ( 200 );
  Nosound;
 end;
End;

{Procedura per la visualizzazione del file con le istruzioni del gioco}
Procedure Istruzioni;
 Var
  Istr : Text;
  Linea: string;
  CNLinee: integer;

Begin
 Assign(Istr, 'Istr.Dat');
 Reset (Istr);
 clrscr;
 CNLinee := 0;
 TextColor (LIGHTGRAY);
 While EOF(Istr)=False DO
 begin
  {Scrolling del video}
  if CNLInee = 23 then
   begin
    gotoXY(24,25);
    write ('Premere un tasto per continuare');
    repeat until (Keypressed);
    WaitChar := ReadKey;
    ClrScr;
    CNLinee := 0;
   end;
  readln(Istr,Linea);
  writeln(Linea);
  CNLinee:= CNLinee + 1
 end;
 GotoXY(24,25);
 Write ('Premere un tasto per continuare');
 repeat until (Keypressed);
 WaitChar := ReadKey;
 Close(Istr);
End;

{Procedura per l'aggiornamento della TOP TEN e l'eventuale inserimento}
Procedure Aggiorna_Top10 (Winner: Classificato);
 Var
  Top, Top2 : File of Classificato;
  CNRecord, Posto: integer;

Begin
 Assign(Top, 'Top10.Dat');
 Reset (Top);
 Posto := 0;
 {Caricamento del vettore e verifica della posizione del nuovo punteggio}
 For CNRecord := 1 To 10 Do Read (Top,Classifica[CNRecord]);

 {Sort della classifica tramite While - Do perch gli autori del Pascal hanno
  gentilmente creato un ciclo For privo della possibilit di impostazione dello
  STEP.}
 CNRecord := 10;
 While (CNRecord >= 1) DO
  begin
   If Winner.Punti > Classifica[CNRecord].Punti Then Posto := CNRecord;
   CNRecord := CNRecord - 1;
  end;

 {Inserimento del nuovo punteggio nel caso il giocatore sia entrato nella TOP 10}
 If Posto > 0 Then
  begin
   For CNRecord := 1 To 10 - Posto + 1 Do
    begin
     Classifica[10 - CNRecord + 1].Cognome := Classifica[10 - CNRecord].Cognome;
     Classifica[10 - CNRecord + 1].Nome    := Classifica[10 - CNRecord].Nome;
     Classifica[10 - CNRecord + 1].Punti   := Classifica[10 - CNRecord].Punti;
    end;
   Classifica[Posto].Cognome := Winner.Cognome;
   Classifica[Posto].Nome    := Winner.Nome;
   Classifica[Posto].Punti   := Winner.Punti;

   {Salvataggio della nuova classifica}
   Assign (Top2, 'Top10.Dat');
   Rewrite (Top2);
   For CNRecord := 1 To 10 Do Write (Top2, Classifica[CNRecord]);
   Close(Top2);
  end;
 Close(Top);
end;

{Procedura per la visualizzazione della classifica}
Procedure Top10;
 var
  Punteggi  :file of Classificato;
  Linea     :Classificato;
  CNRecord  :integer;

 Begin
  assign (Punteggi, 'Top10.Dat');
  reset(Punteggi);
  ClrScr;
  TextColor(Red);
  writeln('                              IL GIOCO DELL''OCA');
  writeln(' ');
  writeln( '                   Programma a cura di Vincenzo Scognamiglio');
  writeln('                        realizzato nel Dicembre 1999         ');
  GotoXY( 1, 6);
  writeln('             Ŀ');
  writeln('                                  TOP-10                      ');
  writeln('                                                              ');
  writeln('             Ĵ');
  writeln('                                                           ');
  for CNRecord := 1 to 10 do
   begin
    Read (Punteggi, Classifica[CNRecord]);
    GotoXY( 14, 10 + CNRecord);
    write ('', CNRecord:2, '',Classifica[CNRecord].Cognome,' ':15 - Length (Classifica[CNRecord].Cognome));
    writeln ('    ',Classifica[CNRecord].Nome,' ':15 - Length (Classifica[CNRecord].Nome),
     '    ',Classifica[CNRecord].Punti:5,' ');
   end;
  writeln('                                                           ');
  writeln('             ');
  Suona(20);
  Close(Punteggi);
  repeat until (KeyPressed);
  WaitChar := ReadKey;
 End;

{La procedura carica la tabella standard se NTab = 1 e quella personalizzata se NTab = 2}
Procedure Carica_Tab(NTab: integer);
var
 InpF: File of integer;
 P: Integer;
 NFile: String;
begin
If NTab = 1 Then NFile := 'Tabella.DAT';
If NTab = 2 Then NFile := 'Personal.DAT';
assign (InpF, NFile);
reset (InpF);
for P:=1 to 90 do
 begin
  Read(InpF, Percorso[P]);
  Verde.Posizione := 0;
  Rossa.Posizione := 0;
 end;
Close (InpF);
end;

{Procedura per il salvataggio della tabella personalizzata}
Procedure Salva_Tab;
var
 OutF: File of integer;
 P: Integer;
begin
assign (OutF, 'Personal.Dat');
Rewrite (OutF);
for P:=1 to 90 do
 Write(OutF, Percorso[P]);
close (OutF);
end;

{Disegno dell'orologio sulla mano umana gestita dalla procedura successiva}
Procedure Orologio;
var
 CNTime:integer;
Begin
  SetColor(BROWN);
  FOR CNTime:=0 to 15 DO Rectangle (CNTime,32,CNTime,75);
  SetColor(Yellow);
  SetFillStyle (1,White);
  Circle (7,52,15,1);
  Circle (7,52,14,1);
  Circle (7,52,13,1);
  FillEllipse (7,52,12,12);
  SetColor(BLUE);
  Line (7,52, 10 , 45);
  Line (7,52, 6 , 43);
End;

{Disegno e animazione della mano umana}
Procedure Mano;
 var
 CNStep:integer;
 Begin
  {Disegno della mano e relativa animazione}
  SetColor(LightRED);
  SetFillStyle(1,LightRED);
  FOR CNStep:=15  to 60 DO Rectangle (CNStep,32,CNStep,75);
  FillEllipse (55,33,16,10); { Pollice }
  FillEllipse (55,40,30,8);  { Indice  }
  FillEllipse (55,50,30,8);  { Medio   }
  FillEllipse (55,60,30,8);  { Anulare }
  FillEllipse (55,70,30,8);  { Mignolo }
  Orologio;
  Delay(2000);
  SetColor(BLACK);
  SetFillStyle(1,BLACK);
  FillEllipse (55,33,17,11); { Pollice }
  SetColor(LightRED);
  SetFillStyle(1,LightRED);
  FillEllipse (55,33,8,16);  { Pollice }
  FillEllipse (55,40,55,8);  { Indice  }
  FillEllipse (55,50,60,8);  { Medio   }
  FillEllipse (55,60,55,8);  { Anulare }
  FillEllipse (65,70,40,5);  { Mignolo }
  Orologio;
  SetColor(BLACK);
  FOR CNStep:=0  to 2 DO Line (70,45 + CNStep * 11 ,100,45+ CNStep * 10 );
 End;

{Disegno e animazione della mano Robot}
Procedure Robot;
 Var
 CNStep:integer;

Begin
  {Disegno della mano robot e relativa animazione}
  SetColor(DarkGray);
  SetFillStyle(1,LightGray);
  FillEllipse (30,42,15,15);  { Polso    }
  FillEllipse (55,25, 8, 8);  { Pollice  }
  FillEllipse (68,30, 6, 6);  { 1 dito  }
  FillEllipse (68,43, 6, 6);  { 2 dito  }
  FillEllipse (68,56, 6, 6);  { 3 dito  }
  FOR CNStep:=0  to 20 DO Rectangle (CNStep,25,CNStep,60);
  FOR CNStep:=35  to 65 DO Rectangle (CNStep,23,CNStep,63);
  Delay(2000);
  FillEllipse (30,42,15,15);    { Polso    }
  FillEllipse (55,25, 8, 8);    { Pollice  }
  FillEllipse (68,29, 6,6);     { 1 dito  }
  FillEllipse (68,42, 6,6);     { 2 dito  }
  FillEllipse (68,55, 6,6);     { 3 dito  }
  FOR CNStep:=50  to 60  DO Rectangle (CNStep, 5,CNStep,15);
  FOR CNStep:=0   to 20  DO Rectangle (CNStep,25,CNStep,60);
  FOR CNStep:=35  to 65  DO Rectangle (CNStep,23,CNStep,63);
  FOR CNStep:=72  to 95  DO Rectangle (CNStep,25,CNStep,33);
  FOR CNStep:=72  to 95  DO Rectangle (CNStep,38,CNStep,46);
  FOR CNStep:=72  to 95  DO Rectangle (CNStep,51,CNStep,59);
  FOR CNStep:=102 to 112 DO Rectangle (CNStep,25,CNStep,33);
  FOR CNStep:=102 to 112 DO Rectangle (CNStep,38,CNStep,46);
  FOR CNStep:=102 to 112 DO Rectangle (CNStep,51,CNStep,59);
  FillEllipse (97,29, 4,4);    { 1 dito  }
  FillEllipse (97,42, 4,4);    { 2 dito  }
  FillEllipse (97,55, 4,4);    { 3 dito  }
  SetFillStyle (1, DarkGray);
  FillEllipse (110,29, 10,4);  { 1 dito  }
  FillEllipse (110,42, 10,4);  { 2 dito  }
  FillEllipse (110,55, 10,4);  { 3 dito  }
End;

{Disegno del dado con il calcolo dei 'pallini' e la loro posizione}
Procedure Dadi(Dado1 :Integer);
var
 STs : String;
Begin
 Suona (3);
 SetFillStyle(1,WHITE);
 Setcolor (LIGHTGRAY);
 Bar3D (90,90,110,110,10,TopOn);

 {Disegno del dado:
  Scomposizione degli elementi del dado:

      0       0       A    E
      0   0   0       B  D F
      0       0       C    G

   1 = D
   2 = A,G
   3 = A,D,G
   4 = A,C,E,G
   5 = A,C,D,E,G
   6 = A,B,C,E,F,G

   Utilizzando questa scaletta diventa estremamente semplice disegnare i cerchi
   del dado, si noter che la particolare ripetitivit delle condizioni
  }
 Setcolor (Red);
 Str(Dado1,STs);
 outtextxy(300,20,STs);
 Setcolor (Black);
 SetFillStyle(1,BLACK);

 If Dado1 > 1 then FillEllipse (94,94,2,2);              {A}
 If Dado1 = 6 then FillEllipse (94,100 ,2,2);            {B}
 If Dado1 > 3 then FillEllipse (94,106,2,2);             {C}
 If (Dado1 MOD 2) = 1 Then FillEllipse (100,100,2,2);    {D}
 If Dado1 > 3 then FillEllipse (106,94,2,2);             {E}
 If Dado1 = 6 then FillEllipse (106,100,2,2);            {F}
 If Dado1 > 1 then FillEllipse (106,106,2,2);            {G}

End;

{Disegna il percorso dell'oca, se NOca = 0 quello verde se NOca = 1 quello rosso}
Procedure Perc(NOca: integer);
Var
 CNCase : Integer;
 Testo: string;

Begin
Setcolor (BLACK);
For CNCase := 1 TO 40 Do Line (0, 150 + CNCase + (100 * (NOca - 1)),640,150 + CNCase + (100 * (NOca - 1)));
If NOca = 1 Then
 begin
  For CNCase := 1 TO 10 DO
   begin
    SetColor (GREEN);
    Rectangle ((CNCase - 1) * 60 , 150, CNcase * 60, 170);
    Str (CNCase + (10 * Verde.Decina), Testo);
    If CNCase < 10 Then Testo := ' ' + Testo;
    OutTextXY ((CNCase-1) * 60 + 27, 155,Testo);
    Setcolor (LightGREEN);
    Str (Percorso[CNCase + (10 * Verde.Decina)], Testo);
    If Percorso[CNCase + (10 * Verde.Decina)] = 95  Then Testo := ' B';
    If Percorso[CNCase + (10 * Verde.Decina)] = 100 Then Testo := 'SB';
    If Percorso[CNCase + (10 * Verde.Decina)] = 105 Then Testo := ' M';
    If Percorso[CNCase + (10 * Verde.Decina)] = 110 Then Testo := ' F';
    If Percorso[CNCase + (10 * Verde.Decina)] = CNCase + (10 * Verde.Decina) Then Testo :=' ';
    OutTextXY ((CNCase-1) * 60 + 27, 175,Testo);
   end;
  end;
If NOca = 2 then
 begin
  For CNCase := 1 TO 10 DO
  begin
   SetColor (RED);
   Rectangle ((CNCase - 1) * 60 , 250, CNcase * 60, 270);
   Str (CNCase + (10 * Rossa.Decina), Testo);
   If CNCase < 10 Then Testo := ' ' + Testo;
   OutTextXY ((CNCase-1) * 60 + 27, 255,Testo);
   Setcolor (LightRED);
   Str (Percorso[CNCase + (10 * Rossa.Decina)], Testo);
   If Percorso[CNCase + (10 * Rossa.Decina)] = 95  Then Testo := ' B';
   If Percorso[CNCase + (10 * Rossa.Decina)] = 100 Then Testo := 'SB';
   If Percorso[CNCase + (10 * Rossa.Decina)] = 105 Then Testo := ' M';
   If Percorso[CNCase + (10 * Rossa.Decina)] = 110 Then Testo := ' F';
   If Percorso[CNCase + (10 * Rossa.Decina)] = CNCase + (10 * Rossa.Decina) Then Testo :=' ';
   OutTextXY ((CNCase-1) * 60 + 27, 275,Testo);
  end;
 end;
End;

{Funzione che ritorna come valore il risultato del tiro dadi e che realizza il
 controllo sul numero di dadi da tirare}
Function Tira_Dadi:integer;
 Var
 Dado: Array [1 .. 2] of Integer;
 CNTiri, CNPassi, Tiri: integer;

Begin

  {Controllo la posizione delle oche per sapere il numeri di tiri da effettuare}
  If ((Tiro = True) AND (Verde.Posizione >= 84)) OR ((Tiro = False) AND (Rossa.Posizione >= 84)) Then
   begin
    Tiri    := 1;
    Dado[2] := 0;
   end
  Else
   begin
    Tiri    := 2;
   end;

  {Tiro dei dadi}
  For CNTiri := 1 to Tiri Do
  Begin
   Dado[CNTiri] := Random (6) + 1;
   SetColor(Black);
   For CNPassi := 0 to 110 Do Line (0,CNPassi,320,CNpassi);
   If ((Tiro = True)  AND (Verde.Giocatore.Computer = False)) Then Mano;
   If ((Tiro = False) AND (Rossa.Giocatore.Computer = False)) Then Mano;
   If ((Tiro = False) AND (Rossa.Giocatore.Computer = True )) Then Robot;
   Dadi(Dado[CNTiri]);
   Delay (4500);
  End;
 Tira_Dadi := Dado[1] + Dado[2];
End;

{Procedura per l'impostazione dei nomi e cognomi dei giocatori}
Procedure Imp_Gioc;
Var
 NumGioc, ErrVar: Integer;
 Leggi: String;
Begin
 ClrScr;
 NumGioc := 0;
 While (NumGioc > 2) OR (NumGioc < 1) DO
 begin
  GotoXY (1,1);
  Write ('Numero giocatori:');
  Readln (Leggi);
  Val (Leggi, NumGioc, ErrVar);
 end;
 Writeln;
 Write ('Inserisci il cognome del 1 giocatore:');
 Readln (Verde.Giocatore.Cognome);
 Write ('Inserisci il nome del 1 giocatore   :');
 Readln (Verde.Giocatore.Nome);
 Verde.Giocatore.Computer := False;
 If NumGioc = 2 Then
  begin
   Writeln;
   Write ('Inserisci il cognome del 2 giocatore:');
   Readln(Rossa.Giocatore.Cognome);
   Write ('Inserisci il nome del 2 giocatore   :');
   Readln (Rossa.Giocatore.Nome);
   Rossa.Giocatore.Computer := False;
  end
 else
  begin
   Rossa.Giocatore.Cognome := 'Computer';
   Rossa.Giocatore.Nome    := ' ';
   Rossa.Giocatore.Computer:= True;
  end;
End;

{Controllo della posizione e dei bonus}
Function Contr_Pos (ValDadi: Integer): Integer;
Var
 VecchiaPos, NuovaPos:Integer;
 Passo: Integer;
Begin
 Passo := 1;
 If Tiro = True  Then VecchiaPos := Verde.Posizione;
 If Tiro = False Then VecchiaPos := Rossa.Posizione;
 NuovaPos := VecchiaPos + ValDadi;

 {Calcolo della posizione nel caso il valore del dado sia superiore alla distanza da 90}
 If NuovaPos > 90 Then
  begin
   NuovaPos := 90 - (ValDadi - (90 - VecchiaPos));
   If (NuovaPos - ((NuovaPos - 1) DIV 10) * 10) < (VecchiaPos - ((VecchiaPos - 1) DIV 10) * 10) Then Passo := -1;
  end;

 If NuovaPos <> Percorso [NuovaPos] Then
  begin
   If Percorso [NuovaPos] < 91  Then NuovaPos := Percorso [NuovaPos];

   If Percorso [NuovaPos] = 95 Then
    begin
     If Tiro = True  Then Verde.Giocatore.Punti := Verde.Giocatore.Punti + 1000;
     If Tiro = False Then Rossa.Giocatore.Punti := Rossa.Giocatore.Punti + 1000;
    end;

   If Percorso [NuovaPos] = 100 Then
    begin
     If Tiro = True  Then Verde.Giocatore.Punti := Verde.Giocatore.Punti + (200 * ValDadi);
     If Tiro = False Then Rossa.Giocatore.Punti := Rossa.Giocatore.Punti + (200 * ValDadi);
    end;

   If Percorso [NuovaPos] = 105 Then
     begin
      If Tiro = True  Then Verde.Giocatore.Punti := Verde.Giocatore.Punti - 500;
      If Tiro = False Then Rossa.Giocatore.Punti := Rossa.Giocatore.Punti - 500;
     end;

   If Percorso [NuovaPos] = 110 Then
    begin
      If Tiro = True  Then Verde.Turno_Fermo := True;
      If Tiro = False Then Rossa.Turno_Fermo := True;
    end
  end;

 If Tiro = True  Then Verde.Decina := ((NuovaPos - 1) DIV 10);
 If Tiro = False Then Rossa.Decina := ((NuovaPos - 1) DIV 10);
 If Tiro = True  Then Verde.Posizione := NuovaPos;
 If Tiro = False Then Rossa.Posizione := NuovaPos;

 Contr_Pos := Passo;
End;

{Procedura per la scrittura del punteggio e della distanza tra le oche}
Procedure Tab_Pti;
Var
 Linea, Testo: String;
 CNGen: Integer;

Begin
 SetColor (Black);
 For CNGen := 0   To 60  Do Line (355, CNGen, 640, CNGen);
 For CNGen := 300 To 470 Do Line (0, CNGen, 640, CNGen);
 SetColor(BLUE);
 Rectangle(322,22,600,50);
 Line (548,22,548,50);
 Line (322,36,600,36);
 Linea := Verde.Giocatore.Cognome + ' ' + Verde.Giocatore.Nome;
 OutTextXY (335,25,Linea);
 Str(Verde.Giocatore.Punti, Linea);
 OutTextXY (550,25,Linea);
 Linea := Rossa.Giocatore.Cognome + ' ' + Rossa.Giocatore.Nome;
 OutTextXY (335,40,Linea);
 Str(Rossa.Giocatore.Punti, Linea);
 OutTextXY (550,40,Linea);
 If Verde.Posizione > Rossa.Posizione Then
  begin
   Str (Verde.Posizione - Rossa.Posizione, Testo);
   Testo := 'L''OCA VERDE E'' IN VANTAGGIO DI ' + Testo + ' CASELLE';
   OutTextXY(0, 320, Testo);
  end;
  If Verde.Posizione < Rossa.Posizione Then
  begin
   Str (Rossa.Posizione  - Verde.Posizione, Testo);
   Testo := 'L''OCA ROSSA E'' IN VANTAGGIO DI ' + Testo + ' CASELLE';
   OutTextXY(0, 320, Testo);
  end;
  If Verde.Posizione = Rossa.Posizione Then OutTextXY (0, 320, 'IL GIOCO E'' IN PARITA''');
  If Verde.Posizione = 90 Then OutTextXY (120, 380, 'L''OCA VERDE HA VINTO!!!!!!!!!!!!!!!!!!');
  If Rossa.Posizione = 90 Then OutTextXY (120, 380, 'L''OCA ROSSA HA VINTO!!!!!!!!!!!!!!!!!!');
  SetColor(GREEN);
  Str (Verde.Mosse, Testo);
  Testo := 'L''OCA VERDE HA TIRATO ' + Testo + ' VOLTE';
  OutTextXY (0, 400, Testo);
  SetColor(RED);
  Str (Rossa.Mosse, Testo);
  Testo := 'L''OCA ROSSA HA TIRATO ' + Testo + ' VOLTE';
  OutTextXY (0, 415, Testo);
End;

{Procedura che gestice il gioco tramite l'utilizzo delle altr procedure e
 funzioni per il tiro dei dadi e il controllo della posizione, inoltre questa
 procedura realizza il movimento delle oche sul percorso}
Procedure Gioca;
Var
 Step, CNCase, CNPassi, CNPassiX, Dadi : Integer;
 Testo: string;

Begin
 {Impostazione delle variabili}
 Gioco_In_corso        := True;
 Verde.Turno_Fermo     :=False;
 Rossa.Turno_Fermo     :=False;
 Verde.Posizione       := 0;
 Verde.Giocatore.Punti := 0;
 Rossa.Giocatore.Punti := 0;
 Rossa.Mosse           := 0;
 Verde.Mosse           := 0;
 Rossa.Mosse           := 0;
 Rossa.Posizione       := 0;
 Verde.Decina          := 0;
 Rossa.Decina          := 0;

 {Impostazione dei pixel da avanzare per ogni passo}
 Step                  := 3;

{Scelta casuale del giocatore che deve iniziare, quando 'Tiro'  vero tocca all'oca verde}
 Dadi := Random(2);
 IF Dadi = 0 Then Tiro := False;
 IF Dadi = 1 Then Tiro := True;

 Imp_Gioc;
 InGraph;
 Tab_Pti;

{Disegno del percorso Oca verde}
 Perc(1);

{Disegno del Percorso Oca Rossa}
 Perc(2);

{Ciclo del gioco}
While (Gioco_In_Corso = True) Do
 begin
  {Scritte di pressione di un tasto per il tiro}
  SetColor (Black);
  For CNCase := 470 To 480 Do Line (0, CNCase, 640, CNCase);
  If Tiro = True Then
   begin
    SetColor (GREEN);
    OutTextXY (175, 472, 'PREMI UN TASTO PER TIRARE');
    Repeat Until (KeyPressed);
    ReadChar := ReadKey;
    If ReadChar = #27 Then
     begin
      SetColor (Black);
      For CNCase := 470 To 480 Do Line (0, CNCase, 640, CNCase);
      SetColor (BLUE + BLINK);
      OutTextXY (100, 472, 'DOPO IL TIRO DI DADI PREMI UN TASTO PER USCIRE DAL GIOCO');
      Gioco_In_Corso := False;
     end;
   end;

  If ((Tiro = False) AND (Rossa.Giocatore.Computer = False)) Then
   begin
    SetColor (RED + BLINK);
    OutTextXY (175, 472, 'PREMI UN TASTO PER TIRARE');
    Repeat Until (KeyPressed);
    ReadChar := ReadKey;
    If ReadChar = #27 Then
     begin
      SetColor (Black);
      For CNCase := 470 To 480 Do Line (0, CNCase, 640, CNCase);
      SetColor (BLUE + BLINK);
      OutTextXY (0, 472, 'DOPO IL TIRO DI DADI PREMI UN TASTO PER USCIRE DAL GIOCO');
      Gioco_In_Corso := False;
    end;
  end;

 Dadi := Tira_Dadi;
 Tab_Pti;

 {Movimento oca verde}
 IF Tiro = True  then
  begin
   Verde.Mosse := Verde.Mosse + 1;
   Verde.Giocatore.Punti := Verde.Giocatore.Punti - 10;
   CNPassi  := ((Verde.Posizione - (((Verde.Posizione - 1)DIV 10) * 10)) - 1) * 60;
   PutImage (CNPassi , 110, Verde.Disegno[1]^, XorPut);
   {Verifica della nuova posizione dopo il tiro dei dadi}
   Step     := ABS(Step);
   Step     := Step * Contr_Pos(Dadi);
   CNPassiX := ((Verde.Posizione - (((Verde.Posizione - 1)DIV 10) * 10)) - 1) * 60;
   Perc (1);
   If ((CNPassi > CNPassiX) AND (Step = ABS(Step))) Then CNpassi := 0;
   {Movimento dell'oca sul percorso}
   While (CNPassi <>  CNPassiX) DO
    begin
     PutImage (CNPassi, 110, Verde.Disegno[1]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 110, Verde.Disegno[1]^, XorPut);
     PutImage (CNPassi, 110, Verde.Disegno[2]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 110, Verde.Disegno[2]^, XorPut);
     CNPassi := CNPassi + Step;
     PutImage (CNPassi, 110, Verde.Disegno[1]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 110, Verde.Disegno[1]^, XorPut);
     PutImage (CNPassi, 110, Verde.Disegno[2]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 110, Verde.Disegno[2]^, XorPut);
    end;
   PutImage (CNPassi, 110, Verde.Disegno[1]^, XorPut);
  end;

 {Movimento oca rossa}
 IF Tiro = False then
  begin
   Rossa.Mosse := Rossa.Mosse + 1;
   Rossa.Giocatore.Punti := Rossa.Giocatore.Punti - 10;
   CNPassi := ((Rossa.Posizione - (((Rossa.Posizione - 1) DIV 10) * 10)) - 1) * 60;
   PutImage (CNPassi , 210, Rossa.Disegno[1]^, XorPut);
   {Verifica della nuova posizione dopo il tiro dei dadi}
   Step     := ABS(Step);
   Step     := Step * Contr_Pos(Dadi);
   CNPassiX := ((Rossa.Posizione - (((Rossa.Posizione - 1) DIV 10) * 10)) - 1) * 60;
   Perc (2);
   If ((CNPassi > CNPassiX) AND (Step = ABS(Step))) Then CNPassi := 0;
   {Movimento dell'oca sul percorso}
   While (CNPassi <>  CNPassiX ) DO
    begin
     PutImage (CNPassi, 210, Rossa.Disegno[1]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 210, Rossa.Disegno[1]^, XorPut);
     PutImage (CNPassi, 210, Rossa.Disegno[2]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 210, Rossa.Disegno[2]^, XorPut);
     CNPassi := CNPassi + Step;
     PutImage (CNPassi,  210, Rossa.Disegno[1]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 210, Rossa.Disegno[1]^, XorPut);
     PutImage (CNPassi, 210, Rossa.Disegno[2]^, XorPut);
     Delay(20);
     PutImage (CNPassi, 210, Rossa.Disegno[2]^, XorPut);
    end;
   PutImage (CNPassi, 210, Rossa.Disegno[1]^, XorPut);
  end;
  Tab_Pti;
  Tiro := NOT(Tiro);
  IF (Tiro = True) AND (Verde.Turno_Fermo = True) Then
   begin
    Verde.Turno_Fermo := False;
    Tiro := NOT(Tiro);
   end;
  IF (Tiro = False) AND (Rossa.Turno_Fermo = True) Then
   begin
    Rossa.Turno_Fermo := False;
    Tiro := NOT(Tiro);
   end;
  IF ((Verde.Posizione = 90) OR (Rossa.Posizione = 90)) Then Gioco_In_Corso := False;
  end;
  Repeat until (KeyPressed);
  ReadChar := ReadKey;
  CloseGraph;

  {Caricamento e eventuale aggiornamento della TOP 10}
  If Verde.Posizione = 90 Then Aggiorna_Top10 (Verde.Giocatore);
  If ((Rossa.Posizione = 90) AND (Rossa.Giocatore.Computer = False)) Then Aggiorna_Top10 (Rossa.Giocatore);
  Top10;
  Selezionato := 0;
End;

{Procedura che gestisce la modifica del percorso di gioco e permette l'impostazione
 delle propriet delle caselle di gioco}
Procedure Crea_Tab;
Var
CNCaseX,CNCaseY, CNCaselle, CNGen, ValX, ValY : Integer;
Testo : String;
Pos_In_percX,Pos_In_PercY : Integer;
Creazione, Spazio: boolean;

Begin
 {Impostazione delle variabili locali}
 CNCaselle := 0;
 ValX := 0;
 ValY := 0;
 Spazio := False;
 Pos_In_PercX:= 1;
 Pos_In_PercY:= 1;
 Creazione := True;
 InGraph;
 Setcolor (Blue);

 For CNCaseY := 1 TO 9 DO
 For CNCaseX := 1 TO 10 DO
  begin
   CNCaselle :=  CNCaselle +1;
   Rectangle ((CNCaseX-1) * 60,(CNCaseY-1) * 48, CNcaseX * 60, CNcaseY * 48);
   Str (CNCaselle, Testo);
   If CNCaselle < 10 Then Testo := ' ' + Testo;
   OutTextXY ((CNCaseX-1) * 60 + 27, (CNCaseY-1) * 48 + 24,Testo);

   {Refresh della tabella}
   Setcolor (GREEN);
   Str (Percorso[(CNCaseY-1) * 10 + CNCaseX], Testo);
   If Percorso[(CNCaseY-1) * 10 + CNCaseX] = 95  then Testo := ' B';
   If Percorso[(CNCaseY-1) * 10 + CNCaseX] = 100 then Testo := 'SB';
   If Percorso[(CNCaseY-1) * 10 + CNCaseX] = 105 then Testo := ' M';
   If Percorso[(CNCaseY-1) * 10 + CNCaseX] = 110 then Testo := ' F';
   If (Percorso[(CNCaseY-1) * 10 + CNCaseX ] <> ((CNCaseY-1) * 10 + CNCaseX)) AND
    (Percorso[(CNCaseY-1) * 10 + CNCaseX ] < 91) then Testo := 'J'+ Testo;
   If Percorso[(CNCaseY-1) * 10 + CNCaseX] = (CNCaseY-1) * 10 + CNCaseX Then Testo :=' ';
   OutTextXY ((CNCaseX-1) * 60 + 27, (CNCaseY-1) * 48 + 35,Testo);
   SetColor(BLUE);
  end;
 SetColor(RED);
 OutTextXY (0,440,'e = +1000 <-> b = + 200 * DADI <-> m = -500 <-> d = Elimina valore <-> f = Stop');
 OutTextXY (0,450,'l = Tab standard <-> s = Salva Tab personale <-> r = Carica Tab personale');
 OutTextXY (0,460,'"Spazio" = Seleziona / Deseleziona le caselle <-> Esc = Ritorno al men');
 SetColor(BLUE);
 While (Creazione = True) DO
 Begin
 If Spazio = False then SetColor(GREEN);
 If Spazio = True  Then Setcolor(RED);
 Rectangle ((Pos_In_PercX-1) * 60,(Pos_In_PercY-1) * 48, Pos_In_PercX * 60, Pos_In_PercY * 48);
 repeat until (KeyPressed);
 ReadChar := ReadKey;
 SetColor(BLUE);
 Rectangle ((Pos_In_PercX-1) * 60,(Pos_In_PercY-1) * 48, Pos_In_PercX * 60, Pos_In_PercY * 48);
 {Controllo della pressione di un tasto di controllo}
 case ReadChar of
   #72: Pos_In_PercY := Pos_In_PercY - 1;     {E' stato premuto UP    }
   #80: Pos_In_PercY := Pos_In_PercY + 1;     {E' stato premuto DOWN  }
   #75: Pos_In_PercX := Pos_In_PercX - 1;     {E' stato premuto LEFT  }
   #77: Pos_In_PercX := Pos_In_PercX + 1;     {E' stato premuto RIGHT }
   #27: Creazione    := False;                {E' stato premuto ESC   }
 end;

 {Rettifica delle posizioni nel caso di superamento margine}
 if Pos_In_PercY > 9  Then Pos_In_PercY  := 1;
 if Pos_In_PercY < 1  Then Pos_In_PercY  := 9;
 if Pos_In_PercX > 10 Then Pos_In_PercX  := 1;
 if Pos_In_PercX < 1  Then Pos_In_PercX  := 10;

 {Controllo sui tasti di impostazione delle propriet delle caselle}
 case ReadChar of
  'e': Percorso [(Pos_In_PercY-1) * 10 + Pos_In_PercX] := 95  ;
  'b': Percorso [(Pos_In_PercY-1) * 10 + Pos_In_PercX] := 100 ;
  'm': Percorso [(Pos_In_PercY-1) * 10 + Pos_In_PercX] := 105 ;
  'f': Percorso [(Pos_In_PercY-1) * 10 + Pos_In_PercX] := 110 ;
  'd': Percorso [(Pos_In_PercY-1) * 10 + Pos_In_PercX] := (Pos_In_PercY-1) * 10 + Pos_In_PercX ;
  'l': Carica_Tab(1);
  's': Salva_tab;
  'r': Carica_tab(2);
  ' ': begin
        If Spazio = FALSE Then
         begin
          ValX := Pos_In_PercX;
          ValY := Pos_In_PercY;
         end;
        If Spazio = TRUE Then
         Begin
          Percorso [(ValY - 1)*10 + ValX] := (Pos_In_PercY-1) * 10 + Pos_In_PercX;
          SetColor (BLACK);
          For CNCaselle := (ValX-1) * 60 + 5 to ValX * 60 - 5 Do
           Line (CNCaselle,(ValY-1) * 48 + 32,CNCaselle,(ValY-1) * 48 + 47);
          Setcolor (GREEN);
          Str (Percorso[(ValY-1) * 10 + ValX], Testo);
          If (Percorso[(ValY-1) * 10 + ValX ] <> ((ValY-1) * 10 + ValX)) AND
            (Percorso[(ValY-1) * 10 + ValX ] < 91) then Testo := 'J'+ Testo;
          If Percorso[(ValY-1) * 10 + ValX] = (ValY-1) * 10 + ValX Then Testo :=' ';
          OutTextXY ((ValX-1) * 60 + 27, (ValY-1) * 48 + 35,Testo);
        end;
       Spazio := Not (Spazio);
       end;
  end;

  {Refresh della tabella}
  SetColor (BLACK);
  For CNCaselle := (Pos_In_PercX-1) * 60 + 5 to Pos_In_PercX * 60 - 5 Do
   Line (CNCaselle,(Pos_In_PercY-1) * 48 + 32,CNCaselle,(Pos_In_PercY-1) * 48 + 47);
  Setcolor (GREEN);
  Str (Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX], Testo);
  If (Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX ] <> ((Pos_In_PercY-1) * 10 + Pos_In_PercX)) AND
   (Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercY ] < 91) then Testo := 'J'+ Testo;
  If Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX] = 95  then Testo := ' B';
  If Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX] = 100 then Testo := 'SB';
  If Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX] = 105 then Testo := ' M';
  If Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX] = 110 then Testo := ' F';
  If Percorso[(Pos_In_PercY-1) * 10 + Pos_In_PercX] = (Pos_In_PercY-1) * 10 + Pos_In_PercX Then Testo :=' ';
  OutTextXY ((Pos_In_PercX-1) * 60 + 27, (Pos_In_PercY-1) * 48 + 35,Testo);
  If (ReadChar = 'l') or (ReadChar = 'r') then Creazione := False;
 end; {Chiusura de while}

 {Controllo sugli elementi finali e iniziali del percorso}
 Percorso[1] := 1;
 If Percorso[90] < 90 Then Percorso[90] := 90;

 CloseGraph;
End;

{Blocco principale che gestisce l'evolversi delle chiamate alle procedure}
Begin
  ClrScr;
  Randomize;
  InGraph;              { Inizializzazione grafica }
  Presentazione;        { Animazione iniziale      }
  CloseGraph;
  Carica_Tab(1);        {Caricamento della tabella standard di gioco}
  Selezionato := 0;
  While (Selezionato <> 5) Do
  begin
   Selezionato:=Menu;
   If Selezionato = 1 then Gioca;
   If Selezionato = 2 then Istruzioni;  {Mostra le istruzioni}
   If Selezionato = 3 then Top10;       {Mostra la TOP TEN   }
   If Selezionato = 4 then Crea_Tab;
  end;
 CloseGraph;
 {Scritta finale prima del prompt del DOS}
 ClrScr;
 Writeln ('La vita  come un gioco');
 Writeln ('Si gioca e si rischia senza saperne il motivo');
 Writeln ('Ci si affanna e ci si scoraggia');
 Writeln ('Si gioisce e si continua anche con una sola speranza');
 Writeln ('Si inizia per istinto ma si gioca con ragione');
 Writeln ('Perch un gioco vero non ha senso');
 Writeln ('Lo si gioca tutto e basta!');
 Writeln ('-----------------------------------------------------');
 Writeln ('             Alla prossima volta!!!');
End.